---
title: "The beauty in [infra]structure"
date: 2022-12-10
...

![Girl with purple hair looking at cyberpunk streets at night](/files/blog/beauty-in-structure.webp "Girl with purple hair looking at cyberpunk street at night, generated by Waifu Diffusion v1.3")

For a very long time, like many autistic people growing up, I've approached the world almost exclusively through pattern recognition. Every experience, every situation had to function by a set of rules, and if nobody could tell me what those were, I tried to figure it out for myself. To the dismay of childhood me, this did not work for everything. Where it did work, however, I saw the beauty in the structure that was behind every tiny detail of reality, and I felt calm and safe in the middle of it. In that image I constructed an environment, my safe place, where everything operated to a specific ruleset that I was fully aware of.

### And then I got into computers
Almost a decade ago, I started transferring this concept into the computer realm by means of infrastructure. What started out as a Banana Pi in a hallway closet quickly spiraled into several connected cloud servers that all had a precise list of tasks. Working on this (to me, at the time) megaproject always made me feel safe, because even if the world around me was overwhelming or didn't operate to the ruleset I'd have liked it to, this tiny (albeit digital) world I created kept working exactly as I wanted to, and if it didn't I finally had the ability to *change* it. 

I spent hundreds, if not thousands of hours optimizing every script, every workflow, every part of this system across many years. It wasn't just a project, it was *my* project. And even if most people I knew at the time didn't appreciate or understand enough about it to get what I was doing, I was content with myself because *I* understood, and that was enough for me at the time. I managed to carve my own niche into the world, specific to my wants and needs.

### Life moves pretty fast
Over the years, this system kept growing, and with it, the number of users it served. It went from being my happy place to a system I'm maintaining for my friends, and at the same time the number of people who appreciated me for this work grew immensely. It quickly became the thing I was known for, the person who does all the infra work and keeps things running. While this did have its merits, there came a point where I got progressively more distressed at any broken part of this system because I felt like I was being judged or perceived as a failure by everyone who otherwise appreciated me for maintaining it. Rationally, I was aware this wasn't true, but emotionally I couldn't get there. It started to feel more like a chore, not like something I would do for fun.

Working in a frankly toxic work environment as a systems administrator did not help the situation. I became even more emotionally connected to the state of the infrastructure I was maintaining and when it wasn't working properly, I didn't have the capacity to fix it, precisely because it was broken. The very thing that used to keep me safe turned into the source of my distress.

### Taking a step back
For a while, I couldn't really maintain the system anymore. I spent the little energy I did have to get it into a state where it would mostly keep running by itself, even if that sacrificed functionality or performance. In life terms, I spent my time doing other - less digital - things. Struggling to find a sense of identity in something other than infrastructure, I felt like I was floating in a void. Rapidly cycling between different interests and activities in an attempt to find something that could even come close to the role maintaining infrastructure used to have in my life. In a way, I felt lost, like someone or something had taken away the thing that was at my very core, that every ounce of stability in my life was based on.

A big step forward in this regard was the server migration project (the target server of which is running this very website engine) I finished earlier this year. This made me have a more positive outlook on the way things were heading in regards to maintaining my infrastructure, however I still wasn't able to work on this kind of thing without all the bad feelings associated with it coming back.

### Reconfiguration
The effort however, paid off. A couple weeks ago, something clicked in my brain. It was significantly more sudden than I had expected, but I was finally back at the point I started off all those years ago, once again feeling one with and safe in the sea of orchestrated infrastructure I accumulated across my lifetime. Every tiny component with its own mission, tasks and responsibilities, trying its best. Like a wind-up robot being sent out for a specific purpose and returning with the result to the query. Looking at \[infra\]structure this way is absolutely stunning and beautiful to me, and I'm glad I once again have the ability to do so.

I think many people don't appreciate the intricacies of the systems powering "the internet" anymore these days, instead treating it like a black box. This, of course, has its merits as well, but I believe that despite all the evil that technology is being used for nowadays, we can still use it to aid us in our lives in a healthy way, guide it to help us achieve whatever our own beliefs may be. Nuance is often lost in discussion, especially on the internet, but I think painting technology as either pure good or pure evil won't do us any good in the long run.

### Closing thoughts
To many, system administration is a thankless job, because it only becomes visible when something goes wrong. Either everything is working perfectly and people question what you are doing all day, or everything is on fire and people question your competency.

As a thought experiment, think about all the systems that had to work to make you be able to read this blog post. From your machine, the browser, the operating system, the hardware, connected to an ISP network with all of its thousands of cables, routers and configuration files, through kilometers upon kilometers of fibre, terminating in a data center running my server, running an operating system, running a blog engine. Every part of this process has been meticulously engineered, by hundreds if not thousands of people working in their field of speciality, and it is working consistently and reliably.

That's what true beauty in \[infra\]structure means to me.